Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::IndexIDMap Struct Reference

`#include <MetaIndexes.h>`

Inheritance diagram for faiss::IndexIDMap:

## Public Member Functions
| IndexIDMap (Index *index)
void | add_with_ids (idx_t n, const float *x, const long *xids) override
void | add (idx_t n, const float *x) override
| this will fail. Use add_with_ids
void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
void | train (idx_t n, const float *x) override
void | reset () override
| removes all elements from the database.
long | remove_ids (const IDSelector &sel) override
| remove ids adapted to IndexFlat
void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const

## Public Attributes
Index * | index
bool | own_fields
| ! the sub-index
std::vector< long > | id_map
| ! whether pointers are deleted in destructo
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

Index that translates search results to ids

Definition at line 26 of file MetaIndexes.h.

## Member Function Documentation

void faiss::IndexIDMap::add_with_ids | ( | idx_t | n,
|  | const float * | x,
|  | const long * | xids
| ) |  |
| overridevirtual

Same as add_core, but stores xids instead of sequential ids

Parameters

  xids | if non-null, ids to store for the vectors (size n)

Reimplemented from faiss::Index.

Reimplemented in faiss::IndexIDMap2.

Definition at line 60 of file MetaIndexes.cpp.

void faiss::IndexIDMap::range_search | ( | idx_t | n,
|  | const float * | x,
|  | float | radius,
|  | RangeSearchResult * | result
| ) |  | const
| overridevirtual

query n vectors of dimension d to the index.

return all vectors with distance < radius. Note that many indexes do not implement the range_search (only the k-NN search is mandatory).

Parameters

  x | input vectors to search, size n * d
  radius | search radius
  result | result table

Reimplemented from faiss::Index.

Definition at line 80 of file MetaIndexes.cpp.

void faiss::IndexIDMap::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const
| overridevirtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Implements faiss::Index.

Definition at line 69 of file MetaIndexes.cpp.

void faiss::IndexIDMap::train | ( | idx_t | ,
|  | const float * |
| ) |  |
| overridevirtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::Index.

Definition at line 47 of file MetaIndexes.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/MetaIndexes.h
- /data/users/matthijs/github_faiss/faiss/MetaIndexes.cpp